// PRUSA iteration3
// X end prototype
// GNU GPL v3
// Josef Průša <iam@josefprusa.cz> and contributors
// http://www.reprap.org/wiki/Prusa_Mendel
// http://prusamendel.org

include <configuration.scad>
use <bearing.scad>
use <nuts_and_bolts.scad>
use <Tuerca_Husillo.scad>
distancia =(-22);

module roundedcube(v, r=0) {
 translate([0,r,r]) minkowski()
 {
  cube([v[0]/2,v[1]-r*2,v[2]-r*2]);
  rotate([0,90,0]) cylinder(r=r,h=v[0]/2, $fn=30);
 }
	//No quiero la base redondeada
	cube([v[0],v[1],v[2]/2]);
}

module tuercaza_original(){
  // Tuerca
  difference (){
  union () {
  //Cubo de sujecion
  
  translate(v=[0,distancia+1,13]) 
		cube(size = [15,25,26], center = true);
  //Perimetro
  translate(v=[6,distancia,2])
		rotate([0,0,30])
			cylinder(h = 24, r=14, $fn = 30);
             }
// Agujero grande
  translate(v=[6,distancia,0])
		rotate([0,0,30])
			cylinder(h = 27, r=11.5, $fn = 30);
               }
//Tapa inferior
     difference () {
     	translate(v=[6,distancia,0])
				rotate([0,0,30])
					cylinder(h = 3, r=14, $fn = 30);
     	translate(v=[6,distancia,0])
				rotate([0,0,30])
					cylinder(h = 15, r=6, $fn = 30);
	  		translate(v=[6,distancia-8.8,0])
				rotate([0,0,30])
					cylinder(h = 20, r=1.6, $fn = 30);
	  		translate(v=[6,distancia+8.8,0])
				rotate([0,0,30])
					cylinder(h = 20, r=1.6, $fn = 30);
		}
  //Fin Tuerca}
}

module mi_tuercaza(){
		difference(){
			translate(v=[-5,distancia+1,11]) 
				cube(size = [15,25,22], center = true);
			translate([6,distancia,11])
				tuerca_husillo();
			translate([6,distancia,-2])
				cylinder(r=6,h=30,$fn=100);			
	}

	translate([6,distancia,11])
		soporte();
}


module x_end_base() {
  // Main block
	translate(v=[-14+17/2,-10-2-43/2,0])
		rotate([0,0,90])
			roundedcube(v=[43,17,58], r=3); 
			//cube(size = [17,39+4,42], center = true);
  // Bearing holder
  // Añadido
  translate(v=[6,0,0])
//		vertical_bearing_base();
		vertical_bearing_with_lm8uu();
  //Nut trap
  // Cube
	tuercaza_original();
//	mi_tuercaza();
}

module x_end_holes() {
//	translate(v=[6,0,0])vertical_bearing_holes();
	// Belt hole
	translate(v=[-5.5-10+1.5,-10-4/2,(35/2)+10]) 
		cube(size = [10,44,35], center = true);
  // Bottom pushfit rod
	translate(v=[-14,-40,5])
		rotate(a=[-90,0,0])
			cylinder(r=8.3/2, h=50, $fn=30);
  // Top pushfit rod
	translate(v=[-14,-40,5+x_rod_distance])
		rotate(a=[-90,0,0])
			cylinder(r=8.3/2, h=50, $fn=30);
  // Nut trap
  //translate(v=[0,-17,-1]) cylinder(h = 10, r=5.6/2);
  //translate(v=[0,-17,4]) rotate([0,0,30]) nutHole(5.2);
}


// Final prototype
module x_end_plain()
{
 difference() {
  x_end_base();
  x_end_holes();
 }
}

x_end_plain();